/*
    WorkingDirCmd.cc
 
    Will Eighteen, 2000: will@opaline.demon.co.uk
*/

#include "WorkingDirCmd.h"
#include "Application.h"
#include <LineEdit.h>
#include <InfoDialogManager.h>
#include "OpResources.h"	// this is the only resources file with global resources


WorkingDirCmd::WorkingDirCmd ( const char *name, int active ) :  Cmd ( name, active )
{
	_popupRealised = False;
}


void WorkingDirCmd::doCommand()
{
	if ( _popupRealised == True )
		return;

	char buf[512];
	char help[512];	
	_edit = new LineEdit ( ( char * ) name(), TRUE,
									&WorkingDirCmd::enterCallback,
									&WorkingDirCmd::cancelCallback, ( void * ) this );
                
	/* retrieve resource to be displayed */
 	snprintf ( buf, sizeof ( buf ), "%s", mixwaveResources->workingDir());
	buf [ sizeof ( buf ) - 1 ] = 0;
	strcpy ( help, "Directory used for Mixwave output files; default " );
	strncpy ( help, buf, sizeof ( help ) - strlen ( help ) - 1 );
	help [ sizeof ( help ) - 1 ] = 0;
	
	_edit->setColumns ( strlen ( buf ) );	// set width before instantiation
	_edit->setHelp ( help );
	_edit->execute();
	_edit->setText ( buf );	// can't set text before instantiation...
	_popupRealised = True;
}


void WorkingDirCmd::undoCommand()
{
	// not implemented
}


void WorkingDirCmd::enterCallback ( void *clientData, char *text )
{
	char buf[256];
	
	WorkingDirCmd *obj = ( WorkingDirCmd * ) clientData;

	if ( strcmp ( text, mixwaveResources->workingDir() ) != 0 )
	{
		strncpy ( buf, text, sizeof ( buf ) );
		buf [ sizeof ( buf ) - 1 ] = 0;
		obj->enter ( buf );
	}

	obj->_popupRealised = False;
	delete obj->_edit;
}


void WorkingDirCmd::enter ( char *text )
{
	char buf[ strlen ( text ) + 2 ];
	
	strncpy ( buf, text, sizeof ( buf ) );
	buf [ sizeof ( buf ) - 1 ] = 0;
		
	if ( buf [ strlen ( buf ) - 1 ] != '/' )
		strncat ( buf, "/", sizeof ( buf ) - strlen ( buf ) - 1 );

	mixwaveResources->workingDir ( buf );
}


void WorkingDirCmd::cancelCallback ( void *clientData )
{
	WorkingDirCmd *obj = ( WorkingDirCmd * ) clientData;

	obj->_popupRealised = False;
	delete obj->_edit;
}
