/*
 DialogCallbackData.h
 
 Douglas A. Young, 'Object-oriented Programming with C++ and OSF/Motif'
 2nd ed., Prentice-Hall
*/

#ifndef DIALOGCALLBACKDATA
#define DIALOGCALLBACKDATA

typedef void ( *DialogCallback ) ( void * );


class DialogCallbackData
{
	public:
		DialogCallbackData ( void *clientData, DialogCallback ok,
				     DialogCallback cancel, DialogCallback help )
		{
			_ok = ok;
			_help = help;
			_cancel = cancel;
			_clientData = clientData;
		}
		
		DialogCallback ok() { return ( _ok ); }
		DialogCallback help() { return ( _help ); }
		DialogCallback cancel() { return ( _cancel ); }
		void *clientData() { return ( _clientData ); }
		
	private:
		DialogCallback _ok;
		DialogCallback _help;
		DialogCallback _cancel;
		void *_clientData;
};
	
#endif


/*
  Note:
  
  The DialogManager uses this as a container for information passed to callbacks.
  */
